:li

!!! Listing 1

int x, y, z;
while (cin) {
    cin >> x;
    cin >> y;    // y und z wird nichts zugewiesen, falls
    cin >> z;    // im ersten Statement ein Fehler auftrat.
    if (cin.good()) {
        // x, y, z sind sicher initialisiert
        f(x, y, z);
    }
}

!!! Ende Listing 1

!!! Listing 2

#include <setjmp.h>

void f(int bedingung)
{
    // ...
    if (bedingung)
        longjmp(setjmp_context, 1);
    // ...
}

void g()
{
    String resource("Destruktor wird nicht aufgerufen");
    String *sp = new String("Speicherplatz geht verloren");
    f(1);
    delete sp; // wird nie ausgefuehrt
}

void main()
{
    if (!setjmp(setjmp_context) {
        g();
    }
    else {
        // Dieser Zweig wird nur im Fehlerfall ausgefuehrt
    }
}

!!! Ende Listing 2

!!! Listing 3

void f()
{
    int i = 0;
    try {
        int v = getValue();
        i++;
    }
    catch(NoValue n) {
        int c = n.status();
        // v ist unbekannt
        i--;
    }
    // v , c, n sind unbekannt
    if (i > 0)
        // keine Ausnahme aufgetreten
    else
        // es ist was schiefgelaufen
}

!!! Ende Listing 3

!!! Listing 5

template <class T>
Container<T>::Container(const Container<T> &c) : nElem(c.nElem)
{
    int i;
    // tpArray und nElem sind Mitgliedsvariablen
    T **ctp = c.tpArray;
    T **tp = tpArray = new T*[nElem];
    try {
        for (i = 0; i < nElem; i++)
            *tp++ = new T(**ctp++);
    }
    catch(OutOfMemory) {
        for (; i > 0; i--)
            delete *(--tp);
        delete [] tpArray;
        throw;   // Wir haben nur aufgeraeumt, aber nicht
                // die Ausnahme behandelt.
    }
}

!!! Ende Listing 5

!!! Listing 6

template <class T>
class Ptr {
    T *p;
    Ptr(const Ptr<T> &) {} // verhindere Kopien
public:
    Ptr(const T&t) { p = new T(t); }
    T *operator ->() { return p; }
};

!!! Ende Listing 6

